#!/usr/bin/env python
#
# signal2.py
# An example of how to catch a system signal
# Note: we would have cleaner code with a context manager; I will leave
#       that as an exercise for the reader :)

import sys
import signal
import time

signal_counter = 0
counter_limit = 3

def SignalHandler(signal, frame):
    # Our signal handler
    global signal_counter
    signal_counter += 1

    print "Caught signal '%s' %d time(s)" % (str(signal), signal_counter)
    if signal_counter >= counter_limit:
        print "Hit our limit of %d times, now exiting" % (counter_limit)
        sys.exit(1)

print "We are going to spin until we receive a signal"
signal.signal(signal.SIGINT, SignalHandler)
while True:
    time.sleep(0.1)

print "We will never get to here"

