#!/usr/bin/env python
#
# uniq4.py
# Now supports argument parsing

import sys
import argparse

from uniqsort import uniqcr

# ------------------------------------------------------------------------------

if __name__ == '__main__':

    parser = argparse.ArgumentParser(description = "Sort & count unique lines")

    parser.add_argument("-i", dest = "input_name", help = "Input filename")
    parser.add_argument("-c", dest = "count", action = "store_true", 
                        default = False, help = "Display count for each occurrence")
    parser.add_argument("-r", dest = "reverse", action = "store_true", 
                        default = False, help = "Display from lowest to highest")
    
    args = parser.parse_args()

    if args.input_name:
        f = open(args.input_name, 'r')
    else:
        f = sys.stdin
    data = [line.rstrip() for line in f]

    for entry in uniqcr(data, reversed = args.reverse):
        if args.count:
            print "%8d\t%s" % (entry[1], entry[0])
        else:
            print entry[0]

